import es
import random
import gamethread
import playerlib

import wcs
from wcs import wcs

name   = 'Donatello'
race   = wcs.Race(name)

race.registerAuthor('Wolf')

######################################
config = race.config()
text   = race.loadStrings()

config.addComment('********************')
config.addComment('Turtle Training')
config.addComment('  Gain more health, speed, high jump and a chance to evade when hit')
config.addComment('********************')
config.addComment()
trainingMaxLevel      = config.addVar('trainingMaxLevel',     10, 'Max level')
trainingLevelInterval = config.addVar('trainingLevelInterval', 2, 'Level interval')
trainingHealth        = config.addVar('trainingHealth',       10, '10 health per level')
trainingSpeed         = config.addVar('trainingSpeed',         3, '.03 speed per level')
trainingJump          = config.addVar('trainingJump',          6, '1 - level * 6 * .01')
trainEvadePercent     = config.addVar('trainEvadePercent',     4, '4 * level')

config.addComment()
config.addComment('********************')
config.addComment('Weapon Training')
config.addComment('  Do extra damage')
config.addComment('********************')
config.addComment()
weaponMaxLevel      = config.addVar('weaponMaxLevel',     10, 'Max level')
weaponLevelInterval = config.addVar('weaponLevelInterval', 3, 'Level interval')
weaponDamage        = config.addVar('weaponDamage',        5, 'Extra damage') 

config.addComment()
config.addComment('********************')
config.addComment('Hard Shell')
config.addComment('  Gain more armor')
config.addComment('********************')
config.addComment()
shellMaxLevel      = config.addVar('shellMaxLevel',     10, 'Max level')
shellLevelInterval = config.addVar('shellLevelInterval', 2, 'Level interval')
shellArmor         = config.addVar('shellArmor',       100, '100 armor per level')

config.addComment()
config.addComment('********************')
config.addComment('Jet Pack')
config.addComment('  +Ultimate Fly') 
config.addComment('********************')
config.addComment()
jetMaxLevel      = config.addVar('jetMaxLevel',      5, 'Max level')
jetMinLevel      = config.addVar('jetMinLevel',     30, 'Min level')
jetLevelInterval = config.addVar('jetLevelInterval', 5, 'Level interval')
jetCoolDown      = config.addVar('jetCoolDown',      7, 'Cool down time')
jetTime          = config.addVar('jetTime',          4, 'Time in air')

config.load(True)
########################################
wcs.Race(name).registerSkill("Turtle Training", int(trainingMaxLevel), int(trainingLevelInterval), "You gain more health, speed and higher jump as well as a chance to evade attacks.")
wcs.Race(name).registerSkill("Weapon Training", int(weaponMaxLevel), int(weaponLevelInterval), "You learn to master your weapon.")
wcs.Race(name).registerSkill("Hard Shell", int(trainingMaxLevel), int(trainingLevelInterval), "Your hard shell will protect you from most attacks.")
wcs.Race(name).registerUltimate("Jet Pack", int(jetMinLevel), int(jetMaxLevel), int(jetLevelInterval), "Your hard work paid off with the jet pack. <+Ultimate>") 
########################################

def downloads():
    es.stringtable('downloadables', 'materials/models/player/techknow/tmnt/purple.vmt')
    es.stringtable('downloadables', 'materials/models/player/techknow/tmnt/purple.vtf')
    es.stringtable('downloadables', 'materials/models/player/techknow/tmnt/body.vmt')
    es.stringtable('downloadables', 'materials/models/player/techknow/tmnt/body.vtf')
    es.stringtable('downloadables', 'materials/models/player/techknow/tmnt/body_n.vtf')
    es.stringtable('downloadables', 'materials/models/player/techknow/tmnt/color_n.vtf')
    es.stringtable('downloadables', 'materials/models/player/techknow/tmnt/eyes.vmt')
    es.stringtable('downloadables', 'materials/models/player/techknow/tmnt/weapons.vmt')
    es.stringtable('downloadables', 'materials/models/player/techknow/tmnt/weapons.vtf')
    es.stringtable('downloadables', 'materials/models/player/techknow/tmnt/weapons_n.vtf')
    es.stringtable('downloadables', 'models/player/techknow/tmnt/donatello.dx80.vtx')
    es.stringtable('downloadables', 'models/player/techknow/tmnt/donatello.dx90.vtx')
    es.stringtable('downloadables', 'models/player/techknow/tmnt/donatello.mdl')
    es.stringtable('downloadables', 'models/player/techknow/tmnt/donatello.phy')
    es.stringtable('downloadables', 'models/player/techknow/tmnt/donatello.sw.vtx')
    es.stringtable('downloadables', 'models/player/techknow/tmnt/donatello.vvd')

def load():
    downloads()

def es_map_start(ev):
    downloads()

def player_spawn(ev):
    userid = ev['userid']
    player = wcs.Command(userid)
    
    if wcs.GetRace(userid) == name:
        playerlib.getPlayer(userid).set('model', 'models/player/techknow/tmnt/donatello.mdl')
        
        es.server.cmd('est_RemoveWeapon %s %s'%(userid, 1))
        es.server.cmd('est_RemoveWeapon %s %s'%(userid, 2))	

        turtleTrainingLevel = wcs.GetLevel(userid, name, 'Turtle Training')
        if turtleTrainingLevel:

            speed  = turtleTrainingLevel * int(trainingSpeed) * .01
            health = turtleTrainingLevel * int(trainingHealth)
            jump   = 1 - turtleTrainingLevel * int(trainingJump) * .01
                
            player.SpeedAdd(speed)
            player.HealthAdd(health)
            player.SetGravity(jump)
                
            es.tell(userid, '#multi', text('training', {'speed': speed * 100, 'jump': jump * 100, 'health': health}, playerlib.getPlayer(userid).get("lang") ) )
            
        armorLevel = wcs.GetLevel(userid, name, 'Hard Shell')
        if armorLevel:
            armor = armorLevel * int(shellArmor)
            
            player.Armor(armor)
            
            es.tell(userid, '#multi', text('shell', {'armor': armor}, playerlib.getPlayer(userid).get("lang") ) )
            
def player_jump(ev):
    userid = ev['userid']
    player = wcs.Command(userid)
    turtleTrainingLevel = wcs.GetLevel(userid, name, 'Turtle Training')
    if turtleTrainingLevel:
        jump   = 1 - turtleTrainingLevel * int(trainingJump) * .01
        player.SetGravity(jump)
    
def item_pickup(ev):
    userid = ev['userid']
    
    if wcs.GetRace(userid) == name:
        es.server.cmd('est_RemoveWeapon %s %s'%(userid, 1))
        es.server.cmd('est_RemoveWeapon %s %s'%(userid, 2))

def player_hurt(ev):
    userid   = ev['userid']
    attacker = ev['attacker']
    damage   = int(ev['dmg_health'])
    victim   = wcs.Command(userid)
    
    weaponLevel = wcs.GetLevel(attacker, name, 'Weapon Training') * (int(weaponDamage) * .01)
    if ev['weapon'] == "knife" and weaponLevel:
        victim.Damage(damage * weaponLevel, 32, attacker)
        es.tell(attacker, '#multi', text('weapon attacker', {'damage' : damage * weaponLevel, 'player': es.getplayername(userid)}, playerlib.getPlayer(attacker).get("lang") ) )
        es.tell(userid, '#multi', text('weapon victim', {'damage' : damage * weaponLevel, 'player': es.getplayername(attacker)}, playerlib.getPlayer(attacker).get("lang") ) )

def prep_hurt(ev):
    userid   = ev['userid']
    attacker = ev['attacker']
    damage   = int(ev['dmg_health'])
    victim   = wcs.Command(userid)
    
    if attacker:
        evadeLevel = wcs.GetLevel(userid, name, 'Turtle Training') * int(trainEvadePercent)
        if evadeLevel:
            if evadeLevel >= random.randint(1,100):
                victim.SaveLife(damage)
                es.tell(userid, '#multi', text('evade', {'damage' : damage}, playerlib.getPlayer(userid).get("lang") ) )
                
def player_ultimate_on(ev):
    userid = ev['userid']
    
    jetPackLevel = wcs.GetLevel(userid, name, 'Jet Pack')
    time         = jetPackLevel * jetTime
    coolDown     = 60 - int(jetPackLevel * jetCoolDown)
    
    if jetPackLevel:
        playerlib.getPlayer(userid).set('jetpack', 1)
        es.tell(userid, '#multi', text('jet on', {'time' : time}, playerlib.getPlayer(userid).get("lang") ) )
        gamethread.delayedname(time, '%s_Crash' %userid, Crash, userid)
        wcs.Command(userid).SetCoolDown('Jet Pack', coolDown)
 
def Crash(userid):
    playerlib.getPlayer(userid).set('jetpack', 0)
    es.tell(userid, '#multi', text('crash', playerlib.getPlayer(userid).get("lang") ) )
    gamethread.cancelDelayed('%s_Crash' %userid)
    
def player_ultimate_off(ev):
    userid = ev['userid']
    
    jetPackLevel = wcs.GetLevel(userid, name, 'Jet Pack')
    if jetPackLevel:
        playerlib.getPlayer(userid).set('jetpack', 0)
        es.tell(userid, '#multi', text('jet off', playerlib.getPlayer(userid).get("lang") ) )
        gamethread.cancelDelayed('%s_Crash' %userid)